VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   1620
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   3360
   LinkTopic       =   "Form1"
   ScaleHeight     =   1620
   ScaleWidth      =   3360
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdGo 
      Caption         =   "Go"
      Default         =   -1  'True
      Height          =   375
      Left            =   2520
      TabIndex        =   3
      Top             =   120
      Width           =   735
   End
   Begin VB.TextBox txtText 
      Height          =   285
      Left            =   720
      TabIndex        =   2
      Text            =   "VB HELPER"
      Top             =   120
      Width           =   1335
   End
   Begin VB.PictureBox picCaptcha 
      BackColor       =   &H00FFFFFF&
      Height          =   855
      Left            =   120
      ScaleHeight     =   795
      ScaleWidth      =   3075
      TabIndex        =   0
      Top             =   600
      Width           =   3135
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Text:"
      Height          =   195
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   360
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateFont Lib "gdi32" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal i As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Private Const LOGPIXELSY = 90        '  Logical pixels/inch in Y

Private Sub MakeCaptchaImage(ByVal pic As PictureBox, ByVal txt As String, ByVal min_size As Integer, ByVal max_size As Integer)
Dim wid As Single
Dim hgt As Single
Dim ch_wid As Single
Dim i As Integer
Dim font_size As Single
Dim ch As String
Dim X As Single
Dim Y As Single
Dim prev_angle As Single
Dim angle As Single
Dim x1 As Single
Dim y1 As Single
Dim x2 As Single
Dim y2 As Single

    ' See how much room is available for each character.
    wid = pic.ScaleWidth
    hgt = pic.ScaleHeight
    ch_wid = wid / Len(txt)

    ' Draw each character.
    prev_angle = 0
    pic.Cls
    Randomize
    For i = 1 To Len(txt)
        ' Get the character and font size.
        ch = Mid$(txt, i, 1)
        font_size = min_size + Rnd * (max_size - min_size)

        ' Get the position.
        X = (i - 0.75 + Rnd * 0.5) * ch_wid
        Y = hgt / 2 + Rnd * (hgt - pic.ScaleY(font_size, vbPoints, vbTwips))

        ' Get the angle.
        angle = prev_angle
        Do While Abs(angle - prev_angle) < 10
            angle = -20 + Rnd * (20 - -20)
        Loop
        prev_angle = angle

        ' Draw the next character.
        DrawCenteredRotatedText picCaptcha, ch, X, Y, angle, font_size
    Next i

    ' Mess things up a bit.
    For i = 1 To 10
        x1 = Rnd * wid
        y1 = Rnd * hgt
        x2 = Rnd * wid
        y2 = Rnd * hgt
        pic.Line (x1, y1)-(x2, y2)
    Next i
    For i = 1 To 10
        x1 = Rnd * wid
        y1 = Rnd * hgt
        x2 = Rnd * wid
        y2 = Rnd * hgt
        pic.Line (x1, y1)-(x2, y2), vbWhite
    Next i
End Sub
Private Sub DrawCenteredRotatedText(ByVal pic As PictureBox, ByVal txt As String, ByVal X As Single, ByVal Y As Single, ByVal angle As Single, ByVal font_points As Integer)
Const CLIP_LH_ANGLES As Long = 16   ' Needed for tilted fonts.
Const PI As Single = 3.14159265

Dim font_units As Single
Dim escapement As Long
Dim oldfont As Long
Dim newfont As Long
Dim wid As Single
Dim hgt As Single
Dim wx As Single
Dim wy As Single
Dim hx As Single
Dim hy As Single
Dim theta As Single
Dim ox As Single
Dim oy As Single

    font_units = font_points * GetDeviceCaps(pic.hdc, LOGPIXELSY) / 72
    escapement = CLng(angle * 10)
    newfont = CreateFont(CLng(font_units), 0, escapement, escapement, 700, _
        False, False, False, 0, 0, CLIP_LH_ANGLES, 0, 0, "Times New Roman")
    ' Select the new font.
    oldfont = SelectObject(pic.hdc, newfont)

    ' Get the text width.
    wid = pic.TextWidth(txt)

    ' Convert the font height in points into twips.
    hgt = pic.ScaleY(font_points, vbPoints, vbTwips)

    theta = -angle * PI / 180 ' Negate because y increases downward.
    wx = wid * Cos(theta) / 2
    wy = wid * Sin(theta) / 2
    hx = -hgt * Sin(theta) / 2
    hy = hgt * Cos(theta) / 2

    ' Find the rotated origin.
    ox = X - wx - hx
    oy = Y - wy - hy

    ' Display the text.
    pic.CurrentX = ox
    pic.CurrentY = oy
    pic.Print txt

    ' Restore the original font.
    newfont = SelectObject(pic.hdc, oldfont)

    ' Free font resources (important!)
    DeleteObject newfont

    ' Draw the center point.
'    pic.Circle (X, Y), 30, vbRed

    ' Draw the rotated bounding box.
'    pic.CurrentX = X - wx - hx
'    pic.CurrentY = Y - wy - hy
'    pic.Line -(X + wx - hx, Y + wy - hy), vbBlue
'    pic.Line -(X + wx + hx, Y + wy + hy), vbBlue
'    pic.Line -(X - wx + hx, Y - wy + hy), vbBlue
'    pic.Line -(X - wx - hx, Y - wy - hy), vbBlue
End Sub


Private Sub cmdGo_Click()
    MakeCaptchaImage picCaptcha, txtText.Text, 30, 40
End Sub

Private Sub Form_Load()
    picCaptcha.AutoRedraw = True
End Sub


